//
//24-311: Numerical Methods
//Spring.java written by Arbtip Dheeravongkit
//Problem Set 7 sample code
//

import java.io.*;
import java.math.*;

public class Spring {

    public static void main(String args[]) throws IOException {
      int i;
      double[][] p = new double[MAX_ITER][3];

      System.out.println("\n>> 24-311:Numerical Methods--2D Unconstrained Optimization <<\n\n");

      // Create a VRML file
      Vrml vrml = new Vrml("output.wrl", "Kenji Shimada (shimada.cmu.edu)");

	///////////////////////////////////////////////

	// Write your optimization code here

	///////////////////////////////////////////////

	// Create a dummy path p[][]

	// 

	//   p[][] is a matrix that stores the path 

	//   created by your optimization codes.

	//   For example p[i][0] and p[i][1] are

	//   x and y coordinate values at i-th iteration.

	//   The potential energy E(x,y) can be calculated

	//   by using a predefined function, "energy".

	// 

	//   The following 5 lines are to create a dummy

	//   path just to show you how to define a path.

	//   You have to replace these with your own

	//   optimization code.



	for (i=0; i<15; i++) {

		p[i][0] = i/100.0;

		p[i][1] = i/100.0 + Math.sin((double)i)/30.0;

		p[i][2] = energy(p[i][0], p[i][1]);

	}







	// Create the canvas in the output file

	vrml.vrml_surface ();



	// Draw the path

	vrml.vrml_path (15, p);

	

	// Close the output wrl file

	vrml.VrmlClose ();


    }

    public static double energy(double x, double y) {

	// This function calculates the energy

	// This function is NOT correct.

	// You have to replace it.



	return  K1 * Math.pow( Math.sqrt( Math.pow(L1 - x,2) + Math.pow(y,2)) - L2, 2) /3.0

		   + K2 * Math.pow( Math.sqrt( Math.pow(L2 - x,2) + Math.pow(y,2)) - L1, 2) /3.0

		   - 0.5 * P1 * x - 0.5 * P2 * y;

    }



    private static final int MAX_ITER = 100;
    private static final int K1 = 800;
    private static final int K2 = 100;
    private static final double L1 = 0.1;
    private static final double L2 = 0.1;
    private static final int P1 = 5;
    private static final int P2 = 5;
}
